package io.tswf.transmutations.staticview.generation

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.meta.StaticViewMethodMetadata
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.tree.ClassNode
import org.objectweb.asm.tree.MethodNode

interface IStaticViewMethodMapper {
    void handleStaticViewMethodMapping(StaticViewMethodMappingContext context)
}

@CheckedMapConstructor
@CompileStatic
class StaticViewMethodMappingContext {
    StaticViewMethodMetadata viewMethodMeta
    ClassNode targetClass
    MethodNode generatedAccessMethodInTarget
}