package io.tswf.transmutations.staticview.meta

import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import org.objectweb.asm.Type
import org.objectweb.asm.tree.ClassNode

@CheckedMapConstructor
@CompileStatic
class StaticViewMetadata {
    ClassNode viewClass
    Type targetType
    List<StaticViewMethodMetadata> viewMethodsMetadata = new ArrayList<>()
}