package io.tswf.transmutations.staticview.exception

import groovy.transform.CompileStatic
import org.objectweb.asm.tree.ClassNode

@CompileStatic
class StaticViewClassReadingException extends RuntimeException {
    ClassNode viewClass

    StaticViewClassReadingException(Throwable e, ClassNode viewClass) {
        super("Exception occurred while trying to read static view class ${viewClass.javaName}:", e)
        this.viewClass = viewClass
    }

    static interface Bypass {

    }
}
