package io.tswf.transmutations.staticview.meta

import groovy.transform.CompileStatic
import io.tswf.transmutations.staticview.generation.IStaticViewMethodMapper
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import io.tswf.transmutations.common.conflict.ConflictingMethodResolveStrategy
import io.tswf.transmutations.common.conflict.IConflictingMethodResolveStrategyProvider
import org.objectweb.asm.tree.MethodNode

@CompileStatic
@CheckedMapConstructor
class StaticViewMethodMetadata implements IConflictingMethodResolveStrategyProvider {
    StaticViewMetadata view
    MethodNode viewMethod
    IStaticViewMethodMapper mapper
    ConflictingMethodResolveStrategy conflictStrategy
}